## boost1.65.1 1.65.1+dfsg

=== libs/hana/CMakeLists.txt ===
# Copyright Louis Dionne 2013-2017
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.8)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")


##############################################################################
# Setup project
#
# We parse the canonical version number located in <boost/hana/version.hpp>.
# This is done to allow the library to be used without requiring a proper
# installation during which the version would be written to this header.
##############################################################################
foreach(level MAJOR MINOR PATCH)
    file(STRINGS include/boost/hana/version.hpp
                 _define_${level}
                 REGEX "#define BOOST_HANA_${level}_VERSION")
    string(REGEX MATCH "([0-9]+)" _version_${level} "${_define_${level}}")
endforeach()

set(Boost.Hana_VERSION_STRING "${_version_MAJOR}.${_version_MINOR}.${_version_PATCH}")
project(Boost.Hana VERSION ${Boost.Hana_VERSION_STRING} LANGUAGES CXX)

# Perform checks to make sure we support the current compiler
include(CheckCxxCompilerSupport)


##############################################################################
# Setup the 'hana' header-only library target, along with its install target
# and exports.
##############################################################################
add_library(hana INTERFACE)
target_include_directories(hana INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                                          $<INSTALL_INTERFACE:include>)
# With Clang on Windows, the -std=c++14 flag is incorrectly set and the compiler
# complains about the unkown option. TODO: Remove this workaround once the
# underlying bug is fixed in CMake: https://gitlab.kitware.com/cmake/cmake/issues/17015
if (NOT (MSVC AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang"))
    target_compile_features(hana INTERFACE cxx_std_14)
endif()

# Export the `hana` library into a HanaConfig.cmake file
install(TARGETS hana EXPORT HanaConfig)
install(EXPORT HanaConfig       DESTINATION lib/cmake/hana)
install(DIRECTORY include/boost DESTINATION include FILES_MATCHING PATTERN "*.hpp")

# Also install an optional pkg-config file
configure_file(cmake/hana.pc.in hana.pc @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/hana.pc" DESTINATION lib/pkgconfig)


##############################################################################
# Setup CMake options
##############################################################################
option(BOOST_HANA_ENABLE_CONCEPT_CHECKS "Enable concept checking in the interface methods." ON)
option(BOOST_HANA_ENABLE_DEBUG_MODE "Enable Hana's debug mode." OFF)

option(BOOST_HANA_ENABLE_STRING_UDL
"Enable the GNU extension allowing the special string literal operator\
 template, which enables the _s suffix for creating compile-time strings." ON)

option(BOOST_HANA_ENABLE_EXCEPTIONS
"Build with exceptions enabled. Note that Hana does not make use of exceptions,\
 but this switch can be disabled when building the tests to assess that it is\
 really the case." ON)


##############################################################################
# Function to setup common compiler flags on tests and examples
##############################################################################
include(CheckCXXCompilerFlag)
function(boost_hana_set_test_properties target)
    target_link_libraries(${target} PRIVATE hana)
    set_target_properties(${target} PROPERTIES CXX_EXTENSIONS NO)

    macro(setflag testname flag)
        check_cxx_compiler_flag(${flag} ${testname})
        if (${testname})
            target_compile_options(${target} PRIVATE ${flag})
        endif()
    endmacro()

    setflag(BOOST_HANA_HAS_FDIAGNOSTICS_COLOR        -fdiagnostics-color)
    setflag(BOOST_HANA_HAS_FTEMPLATE_BACKTRACE_LIMIT -ftemplate-backtrace-limit=0)
    setflag(BOOST_HANA_HAS_PEDANTIC                  -pedantic)
    setflag(BOOST_HANA_HAS_WALL                      -Wall)
    setflag(BOOST_HANA_HAS_WERROR                    -Werror)
    setflag(BOOST_HANA_HAS_WEXTRA                    -Wextra)
    setflag(BOOST_HANA_HAS_WNO_UNUSED_LOCAL_TYPEDEFS -Wno-unused-local-typedefs)
    setflag(BOOST_HANA_HAS_WWRITE_STRINGS            -Wwrite-strings)

    if (NOT BOOST_HANA_ENABLE_EXCEPTIONS)
        setflag(BOOST_HANA_HAS_FNO_EXCEPTIONS -fno-exceptions)
    endif()

    if (NOT BOOST_HANA_ENABLE_CONCEPT_CHECKS)
        target_compile_definitions(${target} PRIVATE -DBOOST_HANA_CONFIG_DISABLE_CONCEPT_CHECKS)
    endif()

    if (BOOST_HANA_ENABLE_DEBUG_MODE)
        target_compile_definitions(${target} PRIVATE -DBOOST_HANA_CONFIG_ENABLE_DEBUG_MODE)
    endif()

    if (BOOST_HANA_ENABLE_STRING_UDL)
        target_compile_definitions(${target} PRIVATE -DBOOST_HANA_CONFIG_ENABLE_STRING_UDL)
        # GCC pretends to have the flag, but produces a "unrecognized command line option"
        # warning when we use it.
        if (NOT ${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
            setflag(BOOST_HANA_HAS_WNO_GNU_STRING_UDL -Wno-gnu-string-literal-operator-template)
        endif()
    endif()
endfunction()


##############################################################################
# Look for the rest of Boost, which is an optional dependency of some tests.
##############################################################################
find_package(Boost 1.59)
if (NOT Boost_FOUND)
    message(WARNING "The rest of Boost was not found; some tests and examples will be disabled.")
endif()


##############################################################################
# Setup custom functions to ease the creation of targets
##############################################################################
#   boost_hana_target_name_for(<output variable> <source file> [ext])
#
# Return the target name associated to a source file. If the path of the
# source file relative from the root of Hana is `path/to/source/file.ext`,
# the target name associated to it will be `path.to.source.file`.
#
# The extension of the file should be specified as a last argument. If no
# extension is specified, the `.cpp` extension is assumed.
function(boost_hana_target_name_for out file)
    if (NOT ARGV2)
        set(_extension ".cpp")
    else()
        set(_extension "${ARGV2}")
    endif()

    file(RELATIVE_PATH _relative "${Boost.Hana_SOURCE_DIR}" "${file}")
    string(REPLACE "${_extension}" "" _name "${_relative}")
    string(REGEX REPLACE "/" "." _name "${_name}")
    set(${out} "${_name}" PARENT_SCOPE)
endfunction()


##############################################################################
# Setup the `check` target to build and then run all the tests and examples.
##############################################################################
add_custom_target(check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Build and then run all the tests and examples.")


##############################################################################
# Setup subdirectories and testing
##############################################################################
enable_testing()
find_program(MEMORYCHECK_COMMAND valgrind)
if (MEMORYCHECK_COMMAND)
    message(STATUS "Found Valgrind: ${MEMORYCHECK_COMMAND}")
    set(MEMORYCHECK_COMMAND_OPTIONS "--leak-check=full --error-exitcode=1")
else()
    message("Valgrind not found")
endif()
include(CTest)

add_subdirectory(benchmark)
add_subdirectory(doc)
add_subdirectory(example)
add_subdirectory(test)

=== libs/serialization/CMake/CMakeLists.txt ===
# CMake build control file for Serialization Library tests

cmake_minimum_required(VERSION 3.0)

if (POLICY CMP0054)
  cmake_policy (SET CMP0054 NEW)
endif (POLICY CMP0054)

if (POLICY CMP0063)
  cmake_policy (SET CMP0063 NEW)
endif (POLICY CMP0063)

if(Boost_USE_STATIC_LIBS)
  project("Serialization-Static")
else()
  project("Serialization-Shared")
endif()

#
# Compiler settings
#

message(STATUS "compiler is ${CMAKE_CXX_COMPILER_ID}" )
add_definitions(${Boost_LIB_DIAGNOSTIC_DEFINITIONS})

if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
  add_definitions( -ftemplate-depth=300 )
  # we use gcc to test for C++03 compatibility
  add_definitions( -std=c++03 )
  message(STATUS "compiler is g++ c++03")
  set(COMPILER_SUPPORTS_CXX11 FALSE)
elseif( CMAKE_CXX_COMPILER_ID STREQUAL "MSVC" )
  add_definitions( /wd4996 )
  message(STATUS "compiler is MSVC")
  set(COMPILER_SUPPORTS_CXX11 TRUE)
elseif( CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=300")
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  set(CMAKE_CXX_FLAGS_DEBUG "-g -O0" )
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-g -O3" )
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++ -dead_strip")
  set(COMPILER_SUPPORTS_CXX11 TRUE)
endif()

#
# IDE settings
#

if( CMAKE_HOST_APPLE )
  # note: it seems that bjam builds both address models in any case
  # so we can defer this decision to the IDE just as we do for debug/release
  # so we'll not use this now
  # set(Boost_ADDRESS_MODEL 64 CACHE INTEGER "32/64 bits")
  set(Boost_USE_STATIC_LIBS ON CACHE BOOL "Link to Boost static libraries")
  set(Boost_USE_MULTITHREADED ON)
else()
  set(Boost_ADDRESS_MODEL 64 CACHE INTEGER "32/64 bits")
  set(Boost_USE_STATIC_LIBS ON CACHE BOOL "Link to Boost static libraries")
  set(Boost_USE_MULTITHREADED ON)
endif()

#
# Locate Project Prerequisites 
#

# Boost

# note: we're assuming that boost has been built with:
# ./b2 —-layout=versioned toolset=clang-darwin link=static,shared variant=debug,release stage

###########################
# special notes for Xcode.

# these three should result in CMake setting the variables
# Boost_SERIALIZATION_LIBRARY_DEBUG … to the correct values.  

# But my current version of CMake doesn't automatically set the library names
# to point to the the libraries to be used.  The variables are created
# but they are not initialized.  So be prepared to set these variables by hand.
# If you want to use the static libraries - point to the boost libraries ending
# in ".a".  If you want to use the shared boost libraries - point to the libraries
# ending in ".dylib".

# But wait - there's more.
# if both lib.a and lib.dylib both exist in the library directory, Xcode will
# automatically chose the *.dylib one - and there's nothing you can do to fix this.
# So my recommendation is 
# a) to place the compiled libraries in two different directories
#    - e.g. stage/lib-static/*.a and stage/lib-shared/*.dylib
#    and set the CMake variable Boost_LIBRARY_DIR to point to one or the other
# b) create two different CMake build directories - build-static and build-shared
#    and switch between projects as desired.  I like to test both since
#    there are things like dead code elimination and visibility which vary
#    between the two environments.
#
#    caveat - as I write this, I've been unable to get the tests on the shared
#    library to function. Problem is that one needs to either put the shared
#    libraries in a special known place or set an environmental
#    variable which points to the shared library directory.  I prefer the latter
#    but I've been unable to figure out how to get Xcode to do on a global basis
#    and it's not practical to do this for 247 test targets one at a time.

# c) The targets in the project will by default be built as universal 32/64 binaries
#    I have yet to experiment with these yet so I just set the target to 64 bit.

# end special note for Xcode
############################

set(Boost_DEBUG true)
set(Boost_DETAILED_FAILURE_MSG true)
set(Boost_FOUND true)

find_package(Boost REQUIRED COMPONENTS system filesystem)
include(CheckIncludeFileCXX)

message(STATUS "Boost_FOUND is ${Boost_FOUND}")

if(Boost_FOUND)
    message(STATUS "Boost Found!")
    message(STATUS "Boost is ${BOOST_ROOT}")
    message(STATUS "Boost directories found at ${Boost_INCLUDE_DIRS}")
    message(STATUS "Boost libraries found at ${Boost_LIBRARY_DIRS}")
    message(STATUS "Boost libraries prefix is  ${Boost_LIB_PREFIX}")
    message(STATUS "Boost component libraries to be linked are ${Boost_LIBRARIES}")
    message(STATUS "Boost version found is ${Boost_VERSION}")
    #include_directories("../include" "${Boost_INCLUDE_DIRS}")
    #link_directories("${Boost_LIBRARY_DIRS}")
else()
    message(STATUS "Boost NOT Found!")
endif()

if(Boost_USE_STATIC_LIBS)
  message(STATUS "Use static libraries")
  set(LINK_TYPE "STATIC")
else()
  message(STATUS "Building shared libraries")
  set(LINK_TYPE "SHARED")
  add_definitions( "-DBOOST_ALL_DYN_LINK=1")
  add_definitions( "-DBOOST_ALL_NO_LIB=1")
  add_definitions( "-DBOOST_LIB_DIAGNOSTICS=1")
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(VISIBILITY_INLINES_HIDDEN)
endif()

###########################
# library builds

add_library(serialization ${LINK_TYPE}
  ../src/archive_exception.cpp
  ../src/basic_archive.cpp
  ../src/basic_iarchive.cpp
  ../src/basic_iserializer.cpp
  ../src/basic_oarchive.cpp
  ../src/basic_oserializer.cpp
  ../src/basic_pointer_iserializer.cpp
  ../src/basic_pointer_oserializer.cpp
  ../src/basic_serializer_map.cpp
  ../src/basic_text_iprimitive.cpp
  ../src/basic_text_oprimitive.cpp
  ../src/basic_xml_archive.cpp
  ../src/binary_iarchive.cpp
  ../src/binary_oarchive.cpp
  ../src/extended_type_info_no_rtti.cpp
  ../src/extended_type_info_typeid.cpp
  ../src/extended_type_info.cpp
  ../src/polymorphic_iarchive.cpp
  ../src/polymorphic_oarchive.cpp
  ../src/singleton.cpp
  ../src/stl_port.cpp
  ../src/text_iarchive.cpp
  ../src/text_oarchive.cpp
  ../src/void_cast.cpp
  ../src/xml_archive_exception.cpp
  ../src/xml_iarchive.cpp
  ../src/xml_oarchive.cpp
  ../src/xml_grammar.cpp
  ../src/utf8_codecvt_facet.cpp
  ../src/basic_xml_grammar.ipp # doesn't show up in "Source Files" in Xcode"'
)

add_library(wserialization  ${LINK_TYPE}
  ../src/codecvt_null.cpp
  ../src/basic_text_wiprimitive.cpp
  ../src/basic_text_woprimitive.cpp
  ../src/text_wiarchive.cpp
  ../src/text_woarchive.cpp
  ../src/xml_wiarchive.cpp
  ../src/xml_woarchive.cpp
  ../src/xml_wgrammar.cpp
  ../src/basic_xml_grammar.ipp # doesn't show up in "Source Files" in Xcode"'
)

# end library build
###########################

###########################
# test targets

function( serialization_test test_name)
  set(arglist)
  foreach(a IN ITEMS ${ARGN} )
    set(arglist ${arglist} ../test/${a}.cpp)
  endforeach()
  message(STATUS ${test_name})
  add_executable( ${test_name} ../test/${test_name}.cpp ${arglist} )
  target_link_libraries(${test_name} serialization wserialization ${Boost_LIBRARIES})
  add_test( ${test_name} ${test_name} )
endfunction(serialization_test)

function(archive_test test_name)
  set(arglist)
  foreach(a IN ITEMS ${ARGN} )
    set(arglist ${arglist} ../test/${a}.cpp)
  endforeach()
  foreach(
    archive-name
    IN ITEMS text_archive text_warchive binary_archive xml_archive xml_warchive
  )
    set(amended_test_name ${test_name}_${archive-name})
    message(STATUS ${amended_test_name})
    add_executable(${amended_test_name} ../test/${test_name}.cpp ${arglist})
    set_property(
      TARGET ${amended_test_name}
      PROPERTY COMPILE_DEFINITIONS BOOST_ARCHIVE_TEST=${archive-name}.hpp
    )
    target_link_libraries(${amended_test_name} serialization wserialization ${Boost_LIBRARIES})
    add_test(${amended_test_name} ${amended_test_name})
  endforeach()
endfunction(archive_test)

function(polymorphic_archive_test test_name)
  set(arglist)
  foreach(a IN ITEMS ${ARGN} )
    set(arglist ${arglist} ../test/${a}.cpp)
  endforeach()
  foreach(
    archive-name
    IN ITEMS text_archive text_warchive binary_archive xml_archive xml_warchive
  )
    set(amended_test_name ${test_name}_polymorphic_${archive-name})
    message(STATUS ${amended_test_name})
    add_executable(${amended_test_name} ../test/${test_name}.cpp ${arglist})
    set_property(
      TARGET ${amended_test_name}
      PROPERTY COMPILE_DEFINITIONS BOOST_ARCHIVE_TEST=polymorphic_${archive-name}.hpp
    )
    target_link_libraries(${amended_test_name} serialization wserialization ${Boost_LIBRARIES})
    add_test(${amended_test_name} ${amended_test_name})
  endforeach()
endfunction(polymorphic_archive_test)

enable_testing()

# serialization(test_dll_exported dll_polymorphic_derived2_lib)
# serialization(test_dll_simple dll_a_lib)
# compile test_dll_plugin.cpp
# Running the following test requires that the test know the directory 
# in which the dll is stored. I don't know how to extract this from bjam
# serialization(test_dll_plugin : : dll_polymorphic_derived2_lib)

serialization_test(test_private_ctor)
serialization_test(test_reset_object_address A)
serialization_test(test_void_cast)
serialization_test(test_mult_archive_types)
serialization_test(test_iterators)
serialization_test(test_iterators_base64)
serialization_test(test_inclusion)
serialization_test(test_smart_cast)
serialization_test(test_codecvt_null ../src/codecvt_null)
serialization_test(test_strong_typedef)

archive_test(test_native_array A)
archive_test(test_boost_array A)
if(COMPILER_SUPPORTS_CXX11)
  archive_test(test_array A)
endif()
archive_test(test_binary)
archive_test(test_bitset)
archive_test(test_class_info_save)
archive_test(test_class_info_load)
archive_test(test_complex)
archive_test(test_contained_class A)
archive_test(test_cyclic_ptrs A)
archive_test(test_delete_pointer)
archive_test(test_deque A)
archive_test(test_derived)
archive_test(test_derived_class A)
archive_test(test_diamond)
archive_test(test_diamond_complex)
archive_test(test_exported polymorphic_base)
archive_test(test_forward_list A)
archive_test(test_forward_list_ptrs A)
archive_test(test_helper_support)
archive_test(test_interrupts)
archive_test(test_list A)
archive_test(test_list_ptrs A)
archive_test(test_map A)
archive_test(test_map_boost_unordered A)
archive_test(test_mi)
archive_test(test_multiple_ptrs A)
archive_test(test_multiple_inheritance)
archive_test(test_no_rtti polymorphic_base polymorphic_derived1)
archive_test(test_new_operator A)
archive_test(test_non_intrusive)
archive_test(test_non_default_ctor)
archive_test(test_non_default_ctor2)
archive_test(test_null_ptr)
archive_test(test_nvp A)
archive_test(test_object)
archive_test(test_optional)
archive_test(test_primitive)
archive_test(test_priority_queue A)
archive_test(test_private_base)
archive_test(test_private_base2)
archive_test(test_queue A)
archive_test(test_recursion A)
archive_test(test_registered)
archive_test(test_shared_ptr)
archive_test(test_shared_ptr_multi_base)
archive_test(test_shared_ptr_132)
archive_test(test_simple_class A)
archive_test(test_simple_class_ptr A)
CHECK_INCLUDE_FILE_CXX(slist SLIST_FOUND)
if(SLIST_FOUND)
  message(STATUS "slist header found")
  archive_test(test_slist A)
  archive_test(test_slist_ptr A)
else()
  message(STATUS "slist header NOT found")
endif()
archive_test(test_stack A)
archive_test(test_split)
archive_test(test_tracking)
archive_test(test_unregistered)
archive_test(test_unique_ptr)
archive_test(test_valarray)
archive_test(test_variant A)
archive_test(test_vector A)
archive_test(test_set A)
archive_test(test_set_boost_unordered A)
if(COMPILER_SUPPORTS_CXX11)
  archive_test(test_set_unordered A)
else()
  CHECK_INCLUDE_FILE_CXX(hash_set HASH_SET_FOUND)
  if(HASH_SET_FOUND)
    archive_test(test_set_hashed A)
  endif()
endif()
if(COMPILER_SUPPORTS_CXX11)
  archive_test(test_map_unordered A)
else()

=== libs/compute/test/extra/CMakeLists.txt ===
# ---------------------------------------------------------------------------
#  Copyright (c) 2015 Kyle Lutz <kyle.r.lutz@gmail.com>
# 
#  Distributed under the Boost Software License, Version 1.0
#  See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt
#
# ---------------------------------------------------------------------------

# include local test headers
include_directories(..)

# Check for linkage problems
add_executable(test_multiple_objects
    test_multiple_objects1.cpp
    test_multiple_objects2.cpp
    )
target_link_libraries(test_multiple_objects
    ${OPENCL_LIBRARIES}
    ${Boost_LIBRARIES}
    )
# link with coverage library
if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  target_link_libraries(test_multiple_objects -fprofile-arcs -ftest-coverage)
endif()
add_test("misc.multiple_objects" test_multiple_objects)

# eigen interop tests
if(${BOOST_COMPUTE_HAVE_EIGEN})
  find_package(Eigen REQUIRED)
  include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
  add_compute_test("interop.eigen" test_interop_eigen.cpp)
endif()

# opencv interop tests
if(${BOOST_COMPUTE_HAVE_OPENCV})
  find_package(OpenCV REQUIRED)
  include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
  add_compute_test("interop.opencv" test_interop_opencv.cpp)
  target_link_libraries(test_interop_opencv ${OpenCV_LIBS})
endif()

# qt interop tests
if(${BOOST_COMPUTE_HAVE_QT})
  # look for Qt4 in the first place
  find_package(Qt4 QUIET)

  if(${QT4_FOUND})
    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtOpenGL)
    include(${QT_USE_FILE})
  else()
    find_package(Qt5Widgets QUIET)

    # look for Qt5
    if(${Qt5Widgets_FOUND})
      find_package(Qt5Core REQUIRED)
      find_package(Qt5Widgets REQUIRED)
      find_package(Qt5OpenGL REQUIRED)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5OpenGL_EXECUTABLE_COMPILE_FLAGS}")
      set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})
    else()
      # no valid Qt framework found
      message(FATAL_ERROR "Error: Did not find Qt4 or Qt5")
    endif()
  endif()

  add_compute_test("interop.qt" test_interop_qt.cpp)
  target_link_libraries(test_interop_qt ${QT_LIBRARIES})

  # the opengl interop test depends on qt to create the opengl context
  add_compute_test("interop.opengl" test_interop_opengl.cpp)
  target_link_libraries(test_interop_opengl ${QT_LIBRARIES})
endif()

# vtk interop tests
if(${BOOST_COMPUTE_HAVE_VTK})
  find_package(VTK REQUIRED)
  include(${VTK_USE_FILE})
  add_compute_test("interop.vtk" test_interop_vtk.cpp)
  target_link_libraries(test_interop_vtk ${VTK_LIBRARIES})
endif()

=== debian/changelog ===
boost1.65.1 (1.65.1+dfsg-0ubuntu5) bionic; urgency=medium

  * Fixup runtime dependency for libboost-numpy, thanks <ricotz>
    for the ping!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Mar 2018 11:21:23 +0100

boost1.65.1 (1.65.1+dfsg-0ubuntu4) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:51:57 +0000

boost1.65.1 (1.65.1+dfsg-0ubuntu2) bionic; urgency=medium

  * coroutine2 is no longer an excludable library. Adjust debian/rules.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Oct 2017 10:18:44 +0100

boost1.65.1 (1.65.1+dfsg-0ubuntu1) bionic; urgency=medium

  [ Steve M. Robbins ]
  * New upstream.
  * Remove "Force use g++-6"
  * patches/chrono-duration.patch: Remove.  Obsoleted by upstream changes.
  * New package for Python.NumPy.  Closes: #853734.
  * New packages for Boost.Container, Boost.Stacktrace.

  [ Dimitri John Ledkov ]
  * Fixup py3 suffixes and symlinks.
  * In asciidoctor docs, do not use external webfonts.
  * In doxygen docs, use local mathjax library.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 25 Oct 2017 15:27:28 +0100

boost1.63 (1.63.0+dfsg-1) unstable; urgency=medium

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Wed, 28 Dec 2016 20:28:31 -0600

boost1.62 (1.62.0+dfsg-4) unstable; urgency=medium

  * New patch upstream-add-degree-reverse_graph.patch.

 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Nov 2016 12:46:50 -0600

boost1.62 (1.62.0+dfsg-3) unstable; urgency=high

  * Build Boost.Python 2 & 3 bindings in separate builddirs. Closes: #842927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Nov 2016 18:44:37 +0000

boost1.62 (1.62.0+dfsg-2) unstable; urgency=medium

  * Limit boost-fiber packages to architectures it is built on.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Oct 2016 08:36:55 +0100

boost1.62 (1.62.0+dfsg-1) unstable; urgency=medium

  * New upstream 1.62.
  * Add packages for Boost.Fiber.
  * Drop package libboost1.62-dbg in favour of using automatic debug
    package generation.
  * Refresh patches.  Drop add-missing-list-include.patch -- applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 16 Oct 2016 01:55:19 -0500

boost1.61 (1.61.0+dfsg-3) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Actually bump standards version.

  [ Steve M. Robbins ]
  * Install /usr/bin/b2, the canonical name of bjam.  Closes: #831431.
  * libboost-iostreams1.61.0: remove Priority Important.  Closes: #829301.

 -- Steve M. Robbins <smr@debian.org>  Sat, 15 Oct 2016 10:59:14 -0500

boost1.61 (1.61.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Aug 2016 21:10:58 +0200

boost1.61 (1.61.0+dfsg-2) experimental; urgency=high

  * Use DEB_HOST_GNU_TYPE for the compiler, because DEB_HOST_MULTIARCH is
    a lie - i386 port doesn't really exist, nor provides/uses i386
    compiler. Fixes FTBFS on i386.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Aug 2016 03:21:52 +0100

boost1.61 (1.61.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Drop upstream cherrypicked patches, no longer needed
  * Update example files and sort them
  * Force use g++-6
  * Add python3:Depends for python packages (pacify dh_python3 warnings)
  * Drop python2.5 depends
  * Require icu 57 or better

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Aug 2016 14:05:10 +0100

boost1.60 (1.60.0+dfsg-6) unstable; urgency=medium

  * patches/fix-ebo_functor_holder.patch: New. Compile fix for copy
    constructor (thanks, Graham Inggs).  Closes: #824021.

  * patches/add-missing-list-include.patch: New.  Add missing <list>
    include (thanks, Graham Inggs).  Closes: #824022.

 -- Steve M. Robbins <smr@debian.org>  Sun, 15 May 2016 23:38:50 -0500

boost1.60 (1.60.0+dfsg-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick upstream graph patch to fix ftbfs when adjacency_matrix.hpp
    template is used. Fixes FTBFS of sfcgal.

  [ Steve M. Robbins ]
  * patches/fix-auto-pointer-registration.patch: New.  Fixes auto-pointer
    registration in Boost.Python, affecting yade.  Closes: #823210.

 -- Steve M. Robbins <smr@debian.org>  Sat, 07 May 2016 22:23:17 -0500

boost1.60 (1.60.0+dfsg-4) unstable; urgency=medium

  * Fully enable context and coroutine on arm64, as it is available there.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 14:52:41 +0100

boost1.60 (1.60.0+dfsg-3) unstable; urgency=medium

  * Drop all the without/just mpi build logic, Ubuntu no longer needs it,
    as Archive Reorg is complete and packages in main can now build-depend
    on packages in universe (e.g. mpi). Boost can now be in-sync between
    Debian and Ubuntu.
  * Drop context/coroutine from arm64, not build there.
  * Arch qualify all context/coroutine dependencies such that we don't
    declare dependencies on non-existant packages.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 11:43:50 +0100

boost1.60 (1.60.0+dfsg-2) unstable; urgency=medium

  * Use --without-coroutine2 on arches that can't build context or
    coroutine; otherwise the build system tries to build context
    anyway.  Upstream bug https://svn.boost.org/trac/boost/ticket/9453

  * patches/fenv.patch: New.  Fix build failure on architectures
    (e.g. power pc) where feclearexcept() and friends may be a macro.

 -- Steve M. Robbins <smr@debian.org>  Sat, 16 Apr 2016 16:12:21 -0500

boost1.60 (1.60.0+dfsg-1) unstable; urgency=medium

  * New upstream version.  Closes: #809228.

  * control: Updated for 1.60 using update-control.py.
    - Add packages for type-erasure.
    - Restrict arch for context, coroutine, to avoid empty packages.
      Closes: #808626
    - Don't ship doc files.  Too many fail lintian checks.

  * copyright: Exclude *.js in repacked tarball to satisfy the pedants.


=== debian/control ===
Source: boost1.65.1
Homepage: http://www.boost.org/
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Boost Team <pkg-boost-devel@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), dctrl-tools, chrpath,
 zlib1g-dev, libbz2-dev, libicu-dev (>= 57), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen, 
 dh-python,
 g++ (>= 4:5-0),
 python, python-all-dev, python-numpy,
 python3, python3-all-dev (>= 3.1), python3-numpy
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-boost/boost/
Vcs-Svn: svn://anonscm.debian.org/pkg-boost/boost/
Standards-Version: 4.1.1

Package: libboost1.65-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-4.8-dev | libstdc++-dev
Suggests: libboost1.65-doc,
 libboost-atomic1.65-dev,
 libboost-chrono1.65-dev,
 libboost-container1.65-dev,
 libboost-context1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el], 
 libboost-coroutine1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.65-dev,
 libboost-exception1.65-dev,
 libboost-fiber1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.65-dev,
 libboost-graph1.65-dev,
 libboost-graph-parallel1.65-dev,
 libboost-iostreams1.65-dev,
 libboost-locale1.65-dev,
 libboost-log1.65-dev,
 libboost-math1.65-dev,
 libboost-mpi1.65-dev,
 libboost-mpi-python1.65-dev,
 libboost-numpy1.65-dev,
 libboost-program-options1.65-dev,
 libboost-python1.65-dev,
 libboost-random1.65-dev,
 libboost-regex1.65-dev,
 libboost-serialization1.65-dev,
 libboost-signals1.65-dev,
 libboost-stacktrace1.65-dev,
 libboost-system1.65-dev,
 libboost-test1.65-dev,
 libboost-thread1.65-dev,
 libboost-timer1.65-dev,
 libboost-type-erasure1.65-dev,
 libboost-wave1.65-dev,
 libboost1.65-tools-dev,
 libmpfrc++-dev, libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev, libboost1.62-dev, libboost1.63-dev
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.65-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev, libboost1.62-tools-dev, libboost1.63-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.65-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.65-dev,
 libboost1.65-tools-dev,
 libboost-atomic1.65-dev,
 libboost-chrono1.65-dev,
 libboost-container1.65-dev,
 libboost-context1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.65-dev,
 libboost-exception1.65-dev,
 libboost-fiber1.65-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.65-dev,
 libboost-graph1.65-dev,
 libboost-graph-parallel1.65-dev,
 libboost-iostreams1.65-dev,
 libboost-locale1.65-dev,
 libboost-log1.65-dev,
 libboost-math1.65-dev,
 libboost-mpi1.65-dev,
 libboost-mpi-python1.65-dev,
 libboost-numpy1.65-dev,
 libboost-program-options1.65-dev,
 libboost-python1.65-dev,
 libboost-random1.65-dev,
 libboost-regex1.65-dev,
 libboost-serialization1.65-dev,
 libboost-signals1.65-dev,
 libboost-stacktrace1.65-dev,
 libboost-system1.65-dev,
 libboost-test1.65-dev,
 libboost-thread1.65-dev,
 libboost-timer1.65-dev,
 libboost-type-erasure1.65-dev,
 libboost-wave1.65-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.65-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-mathjax
Suggests: libboost1.65-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc, libboost1.62-doc, libboost1.63-doc
Description: Boost.org libraries documentation placeholder
 This package originally provided documentation, but has since fallen
 into disrepair and presently provides no documentation.  Please
 use documentation at www.boost.org.

Package: libboost-atomic1.65.1
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.65-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.65-dev (= ${binary:Version}),
 libboost-atomic1.65.1 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev, libboost-atomic1.62-dev, libboost-atomic1.63-dev

Package: libboost-chrono1.65.1
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono
 provides a number of clocks that are thin wrappers around the
 operating system's time APIs, thereby allowing the extraction of wall
 clock time, user CPU time, system CPU time spent by the process:
 .
  * process_real_cpu_clock, captures wall clock CPU time spent by the
    current process.
  * process_user_cpu_clock, captures user-CPU time spent by the current
    process.
  * process_system_cpu_clock, captures system-CPU time spent by the
    current process.
  * a tuple-like class process_cpu_clock, that captures real, user-CPU,
    and system-CPU process times together.
  * a thread_clock thread steady clock giving the time spent by the
    current thread (when supported by a platform).
 .
 Lastly, Boost.Chrono includes typeof registration for duration and
 time_point to permit using emulated auto with C++03 compilers.

Package: libboost-chrono1.65-dev
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.65-dev (= ${binary:Version}),
 libboost-chrono1.65.1 (= ${binary:Version})
Conflicts: libboost-chrono1.48-dev, libboost-chrono1.49-dev, libboost-chrono1.50-dev, libboost-chrono1.52-dev, libboost-chrono1.53-dev, libboost-chrono1.54-dev, libboost-chrono1.55-dev, libboost-chrono1.57-dev, libboost-chrono1.58-dev, libboost-chrono1.60-dev, libboost-chrono1.61-dev, libboost-chrono1.62-dev, libboost-chrono1.63-dev

=== debian/rules ===
#! /usr/bin/make -f

# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono container date-time exception filesystem	\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python numpy program-options python random regex	\
              serialization signals stacktrace system test thread timer \
              type-erasure wave

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_backtrace stacktrace_basic
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

py2versions = $(shell pyversions -rv)
py3versions = $(shell py3versions -rv)
pyversions = $(py2versions) $(py3versions)

# These are special cases for suffixes.  Generally come from --python-buildid, so begin with a dash.
boost_suffixes_python := $(addprefix 3-py,$(subst .,,$(py3versions))) $(addprefix -py,$(subst .,,$(py2versions)))
boost_suffixes_numpy := $(boost_suffixes_python)
boost_suffixes_mpi-python := $(boost_suffixes_python)

py3default = $(subst .,,$(shell py3versions -dv))

# Files that are generated by filtering a template
filtered_files = 

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python2 --with python3

override_dh_auto_configure: user-config.jam make-debhelper

override_dh_auto_build: $(bjam) b2.1 bjam.1
	$(JAM) $(JAM_WITHOUT) --without-python
	for pyver in $(pyversions); do \
	 	pyid=$$(echo $$pyver | tr -d .); \
		echo "Building Boost.Python for python version $$pyver"; \
	 	$(JAM) --build-dir=build-$$pyver --user-config=$(CURDIR)/user-config-$$pyver.jam --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
	 	mv stage/lib/mpi.so stage/lib/mpi-py$$pyid.so || true; \
	done

	cd $(bbv2dir) && ./bootstrap.sh --with-toolset=gcc
	cd tools/bcp && $(JAM)
	cd tools/inspect/build && $(JAM)
	cd tools/quickbook && $(JAM)

testsuite:
	cd status && $(JAM) $(JAM_WITHOUT)

override_dh_auto_clean: clean-debhelper
	-cd tools && $(JAM) clean
	-$(JAM) clean
	rm -rf tools/jam/src/bootstrap
	rm -rf tools/jam/src/bin.*
	rm -ff tools/jam/src/bjam
	rm -rf tools/regression/build/bin
	rm -rf bin.v2 dist
	rm -rf user-config.jam
	rm -rf build-* user-config-*.jam
	rm -rf b2.1 bjam.1
	dh_auto_clean

override_dh_compress:
	dh_compress -Xlibboost$(PKGVERSION)-doc/HTML

override_dh_install:
	$(JAM) --prefix=$(CURDIR)/debian/tmp/usr $(JAM_WITHOUT) \
		--libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
		--without-python install
	for pyver in $(pyversions); do \
		pyid=`echo $$pyver | tr -d .`; \
		$(JAM) --build-dir=build-$$pyver --user-config=$(CURDIR)/user-config-$$pyver.jam --prefix=$(CURDIR)/debian/tmp/usr \
			--libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
			install --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
	done

	# Install Boost.Build v2 & jam
	cd $(bbv2dir) && ./bjam install --prefix=$(CURDIR)/debian/tmp/usr --libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/share/boost-build/example debian/boost-build-examples

	find debian/tmp/usr/include debian/tmp/usr/share/boost-build -type f | xargs chmod 644
	find debian/tmp -name .cvsignore | xargs rm -f
	find debian -empty -type f | xargs rm -f

	# package libboost$(PKGVERSION)-dev
	dh_install -plibboost$(PKGVERSION)-dev \
	   debian/tmp/usr/include/boost \
	   usr/include
	dh_install -plibboost$(PKGVERSION)-tools-dev \
	   debian/tmp/usr/bin/bjam \
	   dist/bin/bcp \
	   dist/bin/inspect \
	   dist/bin/quickbook \
	   usr/bin
	dh_link -plibboost$(PKGVERSION)-tools-dev usr/bin/bjam usr/bin/b2
	dh_installman -plibboost$(PKGVERSION)-tools-dev b2.1 bjam.1 debian/bcp.1 debian/inspect.1 debian/quickbook.1
	dh_install -plibboost$(PKGVERSION)-tools-dev tools/boostbook/xsl/* usr/share/boostbook/xsl
	dh_install -plibboost$(PKGVERSION)-tools-dev tools/boostbook/dtd/* usr/share/boostbook/dtd
	dh_install -plibboost$(PKGVERSION)-tools-dev debian/tmp/usr/share/boost-build

	# package libboost-date-time$(PKGVERSION)-dev
	dh_installdocs -plibboost-date-time$(PKGVERSION)-dev libs/date_time/data

	# package libboost-doc
	rm -rf $(htmldir)
	mkdir -p $(htmldir) 
	#cat debian/documentation-files | xargs cp --parents --target-directory=$(htmldir)
	#find doc libs -name doc | xargs -n1 cp --archive --parents --target-directory=$(htmldir)
	rm -rf $(htmldir)/boost
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/include/boost \
	   usr/share/doc/libboost$(PKGVERSION)-doc/HTML/boost
	# provide a constant symlink to the latest documents and examples
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/share/doc/libboost$(PKGVERSION)-doc/HTML \
	   usr/share/doc/libboost-doc/HTML
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/share/doc/libboost$(PKGVERSION)-doc/examples \
	   usr/share/doc/libboost-doc/examples

# Debian decorates the python-using libraries with a python version suffix ("-py27")
# Create symlinks for the upstream name to the default python version.
# There is a separate set of links for each Python major version.

	# Python2 compatibility links
	dh_link -plibboost-numpy$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy-py27.a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy.a
	dh_link -plibboost-numpy$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy-py27.so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy.so

	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py27.a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python.a
	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py27.so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python.so

	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python-py27.a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python.a
	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python-py27.so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python.so

	# Python3 compatibility links
	dh_link -plibboost-numpy$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy3-py$(py3default).a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy3.a
	dh_link -plibboost-numpy$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy3-py$(py3default).so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_numpy3.so

	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python3-py$(py3default).a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python3.a
	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python3-py$(py3default).so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python3.so

	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python3-py$(py3default).a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python3.a
	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python3-py$(py3default).so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python3.so

	# Python3 old debian compat links
        # upstream started to call things python3-py3*, previously
        # it was python-py3*, provide these old names too.
	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python3-py$(py3default).a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py$(py3default).a
	dh_link -plibboost-python$(PKGVERSION)-dev \

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./g,dversionmangle=s/\+dfsg$//" http://sf.net/boost/boost_([\d_]*)\.tar.bz2

# Note: the above does not work, even with the fixed reflector mentioned
# in this thread: https://lists.debian.org/debian-devel/2016/10/msg00280.html
# Workaround: run: mk-origtargz --repack ../boost_1_63_0.tar.bz2
